(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('rxjs'), require('rxjs/operators')) :
    typeof define === 'function' && define.amd ? define('ng2-responsive-tool', ['exports', '@angular/core', 'rxjs', 'rxjs/operators'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global['ng2-responsive-tool'] = {}, global.ng.core, global.rxjs, global.rxjs.operators));
}(this, (function (exports, i0, rxjs, operators) { 'use strict';

    var ResponsiveConfig = /** @class */ (function () {
        function ResponsiveConfig() {
        }
        return ResponsiveConfig;
    }());

    var Ng2ResponsiveToolModule = /** @class */ (function () {
        function Ng2ResponsiveToolModule() {
        }
        Ng2ResponsiveToolModule.forRoot = function (config) {
            return {
                ngModule: Ng2ResponsiveToolModule,
                providers: [
                    { provide: ResponsiveConfig, useValue: config }
                ]
            };
        };
        return Ng2ResponsiveToolModule;
    }());
    Ng2ResponsiveToolModule.decorators = [
        { type: i0.NgModule, args: [{
                    declarations: [],
                    imports: []
                },] }
    ];

    var ResponsiveToolService = /** @class */ (function () {
        function ResponsiveToolService(sizeConfig) {
            var _this = this;
            this.sizeConfig = sizeConfig;
            this.size = new rxjs.BehaviorSubject(null);
            this.isMobile = new rxjs.BehaviorSubject(null);
            this.sizes = {
                extraSmall: 380,
                small: 600,
                medium: 900,
                large: 1200,
                extraLarge: 1800
            };
            this.size$ = this.size.asObservable().pipe(operators.distinctUntilChanged(), operators.shareReplay(1));
            this.isExtraSmall$ = this.size.asObservable().pipe(operators.map(function (s) { return s > _this.sizes.extraSmall; }), operators.distinctUntilChanged());
            this.isSmall$ = this.size.asObservable().pipe(operators.map(function (s) { return s > _this.sizes.small; }), operators.distinctUntilChanged());
            this.isMedium$ = this.size.asObservable().pipe(operators.map(function (s) { return s > _this.sizes.medium; }), operators.distinctUntilChanged());
            this.isLarge$ = this.size.asObservable().pipe(operators.map(function (s) { return s > _this.sizes.large; }), operators.distinctUntilChanged());
            this.isExtraLarge$ = this.size.asObservable().pipe(operators.map(function (s) { return s > _this.sizes.extraLarge; }), operators.distinctUntilChanged());
            this.isMobile$ = this.isMobile.asObservable().pipe(operators.distinctUntilChanged(), operators.shareReplay(1));
            this.isDesktop$ = this.isMobile$.pipe(operators.map(function (d) { return !d; }));
            this.sizes = sizeConfig !== null && sizeConfig !== void 0 ? sizeConfig : this.sizes;
            this.size.next(window.innerWidth);
            rxjs.fromEvent(window, 'resize').subscribe(function (e) {
                _this.size.next(window.innerWidth);
                _this.isMobile.next(_this.detectIsMobile);
            });
            this.isMobile.next(this.detectIsMobile);
        }
        Object.defineProperty(ResponsiveToolService.prototype, "detectIsMobile", {
            get: function () {
                return /iPhone|iPad|iPod|Android|webOS|Windows Phone|BlackBerry/i.test(navigator.userAgent);
            },
            enumerable: false,
            configurable: true
        });
        ResponsiveToolService.prototype.match = function (condition) {
            return rxjs.of(window.matchMedia("(" + condition + ")").matches).pipe(operators.distinctUntilChanged());
        };
        return ResponsiveToolService;
    }());
    ResponsiveToolService.ɵprov = i0.ɵɵdefineInjectable({ factory: function ResponsiveToolService_Factory() { return new ResponsiveToolService(i0.ɵɵinject(ResponsiveConfig, 8)); }, token: ResponsiveToolService, providedIn: "root" });
    ResponsiveToolService.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    ResponsiveToolService.ctorParameters = function () { return [
        { type: ResponsiveConfig, decorators: [{ type: i0.Optional }] }
    ]; };

    /*
     * Public API Surface of ng2-responsive
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.Ng2ResponsiveToolModule = Ng2ResponsiveToolModule;
    exports.ResponsiveConfig = ResponsiveConfig;
    exports.ResponsiveToolService = ResponsiveToolService;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ng2-responsive-tool.umd.js.map
